<?php
/**
 * @var Template_VariableAccessor $VAR
 * @var array $OPT
 */
?>
<?php if ($OPT['ssl']): ?>
<IfModule mod_ssl.c>
<?php endif; ?>

<VirtualHost <?php echo $OPT['ipAddress']->escapedAddress?>:<?php echo $OPT['ssl'] ? $VAR->server->webserver->httpsPort : $VAR->server->webserver->httpPort ?> <?php echo ($VAR->server->webserver->proxyActive && $OPT['ipAddress']->address !== '127.0.0.1') ? "127.0.0.1:" . ($OPT['ssl'] ? $VAR->server->webserver->httpsPort : $VAR->server->webserver->httpPort) : ''; ?>>
    ServerName "<?php echo $VAR->domain->asciiName ?>"
    <?php if ($VAR->domain->isWildcard): ?>
    ServerAlias  "<?php echo $VAR->domain->wildcardName ?>"
    <?php else: ?>
    ServerAlias "www.<?php echo $VAR->domain->asciiName ?>"
    <?php if ($OPT['ipAddress']->isIpV6()): ?>
    ServerAlias "ipv6.<?php echo $VAR->domain->asciiName ?>"
    <?php else: ?>
    ServerAlias "ipv4.<?php echo $VAR->domain->asciiName ?>"
    <?php endif; ?>
    <?php endif; ?>
<?php foreach ($VAR->domain->webAliases as $alias): ?>
    ServerAlias "<?php echo  $alias->asciiName ?>"
    ServerAlias "www.<?php echo $alias->asciiName ?>"
    <?php if ($OPT['ipAddress']->isIpV6()): ?>
    ServerAlias "ipv6.<?php echo $alias->asciiName ?>"
    <?php else: ?>
    ServerAlias "ipv4.<?php echo $alias->asciiName ?>"
    <?php endif; ?>
<?php endforeach; ?>
<?php if ($VAR->server->webserver->listenLocalhost): ?>
    <?php foreach ($VAR->domain->forwarding->ipAddresses as $ip): ?>
        <?php if ($ip->defaultDomainId === $VAR->domain->id): ?>
    ServerAlias "<?php echo $ip->address ?>"
        <?php endif; ?>
    <?php endforeach; ?>
<?php endif; ?>

<?php if (!$OPT['ssl'] && $VAR->domain->forwarding->sslRedirect): ?>
    <IfModule mod_rewrite.c>
        RewriteEngine On
        RewriteCond %{HTTPS} off
        RewriteRule ^ https://%{HTTP_HOST}%{REQUEST_URI} [R=301,L,QSA]
    </IfModule>
</VirtualHost>
<?php return; ?>
<?php endif; ?>

<?php echo $VAR->includeTemplate('domain/PCI_compliance.php') ?>

    DocumentRoot "<?php echo $VAR->domain->forwarding->vhostDir ?>/httpdocs"

<?php if ($OPT['ssl']): ?>
    <?php $sslCertificate = $VAR->server->sni && $VAR->domain->forwarding->sslCertificate ?
        $VAR->domain->forwarding->sslCertificate :
        $OPT['ipAddress']->sslCertificate; ?>
    <?php if ($sslCertificate->ceFilePath): ?>
    SSLEngine on
    SSLVerifyClient none
    SSLCertificateFile <?php echo $sslCertificate->ceFilePath ?>

        <?php if ($sslCertificate->caFilePath): ?>
        SSLCACertificateFile <?php echo $sslCertificate->caFilePath ?>
        <?php endif; ?>
    <?php endif; ?>
<?php else: ?>
    <IfModule mod_ssl.c>
        SSLEngine off
    </IfModule>
<?php endif; ?>

    <?php echo $VAR->domain->forwarding->extensionsConfigs ?>

</VirtualHost>

<?php if ($OPT['ssl']): ?>
</IfModule>
<?php endif ?>
