<?php
/**
 * @var Template_VariableAccessor $VAR
 * @var array $OPT
 */
?>
<?php if ($VAR->domain->physicalHosting->proxySettings['nginxCacheEnabled']): ?>
    fastcgi_cache_key <?=$VAR->quote($VAR->domain->physicalHosting->proxySettings['nginxCacheKey'])?>;

    fastcgi_no_cache <?=join(' ', array_filter([
        '$no_cache',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassHeaderNocache'] ? '$http_pragma' : '',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassHeaderAuth'] ? '$http_authorization' : '',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassGetNocache'] ? '$arg_nocache' : '',
    ]))?>;
    fastcgi_cache_bypass <?=join(' ', array_filter([
        '$no_cache',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassHeaderNocache'] ? '$http_pragma' : '',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassHeaderAuth'] ? '$http_authorization' : '',
        $VAR->domain->physicalHosting->proxySettings['nginxCacheBypassGetNocache'] ? '$arg_nocache' : '',
    ]))?>;

    fastcgi_cache <?="{$VAR->domain->asciiName}_fastcgi"?>;
    fastcgi_cache_valid <?=$VAR->quote($VAR->domain->physicalHosting->proxySettings['nginxCacheTimeout'])?>;
    fastcgi_cache_use_stale <?=join(' ', array_merge(
        $VAR->domain->physicalHosting->proxySettings['nginxCacheUseStale5xx'] ? ['http_500', 'http_503'] : [],
        $VAR->domain->physicalHosting->proxySettings['nginxCacheUseStale4xx'] ? ['http_403', 'http_404'] : [],
        $VAR->domain->physicalHosting->proxySettings['nginxCacheUseStaleUpdating'] ? ['updating'] : []
    ) ?: ['off'])?>;
    <?php if ($VAR->domain->physicalHosting->proxySettings['nginxCacheUseStaleUpdating']): ?>
        fastcgi_cache_background_update on;
    <?php endif ?>
<?php endif ?>
