<?php /** @var Template_VariableAccessor $VAR */ ?>
<?php /** @var array $OPT */ ?>

<?php foreach ($VAR->server->ipAddresses->all as $ipAddress): ?>
<?php /** @var Template_Variable_IpAddress $ipAddress */ ?>
<?php
    if ($OPT['ssl'] && !$ipAddress->sslCertificate) {
        continue;
    }
?>
server {
    <?php if ($OPT['ssl'] && $OPT['http3']) : ?>
    listen <?php echo $ipAddress->escapedAddress . ':' . $OPT['frontendPort'] ?> quic;
    add_header Alt-Svc <?php echo '\'h3=":' . $OPT['frontendPort'] . '"; ma=86400\'' ?>;
    <?php endif; ?>
    listen <?php echo "{$ipAddress->escapedAddress}:{$OPT['frontendPort']}" . ($OPT['ssl'] ? ' ssl' : '') ?>;
    <?php if ($OPT['ssl'] && $OPT['http2']) : ?>
    http2 on;
    <?php endif; ?>

<?php if (!empty($OPT['serverNames'])): ?>
    server_name <?php echo implode(', ', $OPT['serverNames']); ?>;
<?php endif; ?>

<?php if ($OPT['ssl']): ?>
<?php $sslCertificate = $ipAddress->sslCertificate; ?>
<?php   if ($sslCertificate->ceFilePath): ?>
    ssl_certificate             <?php echo $sslCertificate->ceFilePath ?>;
    ssl_certificate_key         <?php echo $sslCertificate->ceFilePath ?>;
<?php   endif ?>
<?php endif ?>

<?php if (empty($OPT['serverNames'])) { ?>
<?= $VAR->includeTemplate('service/nginxSitePreview.php') ?>
<?php } ?>

    location / {
    <?php if ($OPT['ssl']): ?>
        proxy_pass https://<?php echo $ipAddress->proxyEscapedAddress . ':' . $OPT['backendPort']; ?>;
        proxy_hide_header upgrade;
    <?php else: ?>
        proxy_pass http://<?php echo $ipAddress->proxyEscapedAddress . ':' . $OPT['backendPort']; ?>;
    <?php endif ?>
        proxy_set_header Host $host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    }
}

<?php endforeach; ?>
